=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'uri'

module WeFitter
  class TeamApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Team
    # Creates a new team
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [TeamDetail]
    def team_create(data, opts = {})
      data, _status_code, _headers = team_create_with_http_info(data, opts)
      data
    end

    # Create Team
    # Creates a new team
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TeamDetail, Fixnum, Hash)>] TeamDetail data, response status code and response headers
    def team_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_create ...'
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_create"
      end
      # resource path
      local_var_path = '/team/'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TeamDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Deletes a Team
    # Deletes an existing team
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def team_delete(public_id, opts = {})
      team_delete_with_http_info(public_id, opts)
      nil
    end

    # Deletes a Team
    # Deletes an existing team
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def team_delete_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_delete ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_delete"
      end
      # resource path
      local_var_path = '/team/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List Teams
    # List all available teams
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @return [InlineResponse2005]
    def team_list(opts = {})
      data, _status_code, _headers = team_list_with_http_info(opts)
      data
    end

    # List Teams
    # List all available teams
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @return [Array<(InlineResponse2005, Fixnum, Hash)>] InlineResponse2005 data, response status code and response headers
    def team_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_list ...'
      end
      # resource path
      local_var_path = '/team/'

      # query parameters
      query_params = {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2005')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add member
    # Add member to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfileAsProfilePublicId]
    def team_member_create(public_id, data, opts = {})
      data, _status_code, _headers = team_member_create_with_http_info(public_id, data, opts)
      data
    end

    # Add member
    # Add member to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfileAsProfilePublicId, Fixnum, Hash)>] ProfileAsProfilePublicId data, response status code and response headers
    def team_member_create_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_member_create ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_member_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_member_create"
      end
      # resource path
      local_var_path = '/team/{public_id}/member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfileAsProfilePublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_member_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Remove member
    # Remove a member from the team
    # @param public_id 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def team_member_delete(public_id, profile, opts = {})
      team_member_delete_with_http_info(public_id, profile, opts)
      nil
    end

    # Remove member
    # Remove a member from the team
    # @param public_id 
    # @param profile A profile public_id is expected
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def team_member_delete_with_http_info(public_id, profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_member_delete ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_member_delete"
      end
      # verify the required parameter 'profile' is set
      if @api_client.config.client_side_validation && profile.nil?
        fail ArgumentError, "Missing the required parameter 'profile' when calling TeamApi.team_member_delete"
      end
      # resource path
      local_var_path = '/team/{public_id}/member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'profile'] = profile

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_member_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add member
    # Add member to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfileAsProfilePublicId]
    def team_member_update(public_id, data, opts = {})
      data, _status_code, _headers = team_member_update_with_http_info(public_id, data, opts)
      data
    end

    # Add member
    # Add member to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfileAsProfilePublicId, Fixnum, Hash)>] ProfileAsProfilePublicId data, response status code and response headers
    def team_member_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_member_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_member_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_member_update"
      end
      # resource path
      local_var_path = '/team/{public_id}/member/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfileAsProfilePublicId')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_member_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add members
    # Add members to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsList]
    def team_members_create(public_id, data, opts = {})
      data, _status_code, _headers = team_members_create_with_http_info(public_id, data, opts)
      data
    end

    # Add members
    # Add members to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsList, Fixnum, Hash)>] ProfilePublicIdsList data, response status code and response headers
    def team_members_create_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_members_create ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_members_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_members_create"
      end
      # resource path
      local_var_path = '/team/{public_id}/members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_members_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Add members
    # Add members to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsList]
    def team_members_update(public_id, data, opts = {})
      data, _status_code, _headers = team_members_update_with_http_info(public_id, data, opts)
      data
    end

    # Add members
    # Add members to a team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsList, Fixnum, Hash)>] ProfilePublicIdsList data, response status code and response headers
    def team_members_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_members_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_members_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_members_update"
      end
      # resource path
      local_var_path = '/team/{public_id}/members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_members_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Partial Edit a Team
    # Creates a new team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [TeamDetail]
    def team_partial_update(public_id, data, opts = {})
      data, _status_code, _headers = team_partial_update_with_http_info(public_id, data, opts)
      data
    end

    # Partial Edit a Team
    # Creates a new team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TeamDetail, Fixnum, Hash)>] TeamDetail data, response status code and response headers
    def team_partial_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_partial_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_partial_update"
      end
      # resource path
      local_var_path = '/team/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TeamDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Team
    # Get a single team
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [TeamDetail]
    def team_read(public_id, opts = {})
      data, _status_code, _headers = team_read_with_http_info(public_id, opts)
      data
    end

    # Team
    # Get a single team
    # @param public_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TeamDetail, Fixnum, Hash)>] TeamDetail data, response status code and response headers
    def team_read_with_http_info(public_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_read ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_read"
      end
      # resource path
      local_var_path = '/team/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TeamDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Remove members
    # Remove members from the team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [ProfilePublicIdsList]
    def team_remove_members(public_id, data, opts = {})
      data, _status_code, _headers = team_remove_members_with_http_info(public_id, data, opts)
      data
    end

    # Remove members
    # Remove members from the team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ProfilePublicIdsList, Fixnum, Hash)>] ProfilePublicIdsList data, response status code and response headers
    def team_remove_members_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_remove_members ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_remove_members"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_remove_members"
      end
      # resource path
      local_var_path = '/team/{public_id}/remove_members/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ProfilePublicIdsList')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_remove_members\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Edit Team
    # Creates a new team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [TeamDetail]
    def team_update(public_id, data, opts = {})
      data, _status_code, _headers = team_update_with_http_info(public_id, data, opts)
      data
    end

    # Edit Team
    # Creates a new team
    # @param public_id 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(TeamDetail, Fixnum, Hash)>] TeamDetail data, response status code and response headers
    def team_update_with_http_info(public_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TeamApi.team_update ...'
      end
      # verify the required parameter 'public_id' is set
      if @api_client.config.client_side_validation && public_id.nil?
        fail ArgumentError, "Missing the required parameter 'public_id' when calling TeamApi.team_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TeamApi.team_update"
      end
      # resource path
      local_var_path = '/team/{public_id}/'.sub('{' + 'public_id' + '}', public_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['BearerAdmin', 'BearerProfile']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TeamDetail')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TeamApi#team_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
